//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "M2SDlg.h"
//---------------------------------------------------------------------
#if __BCPLUSPLUS__ != 0x0520
#pragma package(smart_init)
#endif
#pragma resource "*.dfm"
TSeDlg *SeDlg;
//IDirectPlay4ȏŒ`G[lŖڂڂŒ`---------
#define DPERR4_CANNOTCREATESERVER  MAKE_DPHRESULT( 290 )
#define DPERR4_CONNECTIONLOST      MAKE_DPHRESULT( 360 )
//---------------------------------------------------------------------
__fastcall TSeDlg::TSeDlg(TComponent* AOwner, LPDIRECTPLAY3A lpDP,
                GUID appGuid, unsigned MaxPlayers, unsigned MaxNameLen)
  : TForm(AOwner)
{
  lpDP3A = lpDP;
  appguid = appGuid;
  MAXPlayer = (int)MaxPlayers;
  Edit1->MaxLength = MaxNameLen;
  tuduku = RunInTimer = MustStopAsync = false;

  GuidList = (LPGUID)GlobalAlloc(GPTR, MAXPlayer*sizeof(GUID));
  BackStrList = new TStringList();

  // Man2Man Owner TForm ̎͂̂܂Ȃɕ\
  TControl* ctrl = dynamic_cast<TControl*>(Owner);
  if(ctrl){
    TForm* oya = dynamic_cast<TForm*>(GetParentForm(ctrl));
    if(oya){
      Position = poDesigned;
      Left = oya->Left + (oya->Width - Width)/2;
      Top = oya->Top + (oya->Height - Height)/2 + 30;
    }
  }
}
//---------------------------------------------------------------------
void __fastcall TSeDlg::BtnNewClick(TObject *Sender)
{
  //   VKZbV쐬{^NbNƂ̏
  int tmp;
  myname = Edit1->Text.Trim();
  if(myname.Length() == 0){
    MessageBox(SeDlg->Handle, "vC[ĉB","", MB_OK);
    Edit1->SetFocus();
    return;
  }
  if((tmp=myOpen(true))==-1){
    return;
  }else{
    ModalResult = tmp;
  }
}
//---------------------------------------------------------------------------
void __fastcall TSeDlg::OKBtnClick(TObject *Sender)
{
  //   ̃ZbVIAOK{^Ƃ̏
  int tmp;
  AnsiString yourname = ListBox1->Items->Strings[ListBox1->ItemIndex];
  yourname = yourname.SubString(4, yourname.Length()-3).Trim();
   
  myname = Edit1->Text.Trim();
  if(myname.Length() == 0){
    MessageBox(SeDlg->Handle, "vC[ĉB","", MB_OK);
    Edit1->SetFocus();
    return;
  }
  if(0==myname.AnsiCompare(yourname)){
    Edit1->Text = "";
    MessageBox(SeDlg->Handle, "ƈႤvC[ɂĂB","", MB_OK);
    Edit1->SetFocus();
    return;
  }

  if((tmp=myOpen(false))==-1){
    return;
  }else{
    ModalResult = tmp;
  }
}
//---------------------------------------------------------------------------
void __fastcall TSeDlg::BtnEnumClick(TObject *Sender)
{
  DPCAPS dpcaps;
  dpcaps.dwSize = sizeof(DPCAPS);

  lpDP3A->GetCaps(&dpcaps,0);
  Timer1->Interval = dpcaps.dwTimeout/2 + 1000;

  FirstEnum = true;
  enumulate();
  Timer1->Enabled = true;
  BtnEnum->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TSeDlg::Timer1Timer(TObject *Sender)
{
  if(!RunInTimer){      //ꉞr
    RunInTimer = true;
    enumulate();

    for(int i=0;i<SessionCount;i++){  // ԂςĂwB
      if(selectedGuid == GuidList[i]){
        ListBox1->ItemIndex = i;
        break;
      }
      if(i==SessionCount-1)  OKBtn->Enabled = false;
    }
  }
  RunInTimer = false;
}
//---------------------------------------------------------------------------
void TSeDlg::enumulate()
{
  HRESULT hr;
  SessionCount = 0;
  somanypeople = false;

  BackStrList->Clear();
  if(FirstEnum){
    BackStrList->Text = "\n\n\n         ΐ푊TĂ܂";
    ListBox1->Items = BackStrList;
    ListBox1->Update();
  }
  BackStrList->BeginUpdate();

  memset(&sessionDesc, 0, sizeof(DPSESSIONDESC2));
  sessionDesc.dwSize = sizeof(DPSESSIONDESC2);
  sessionDesc.guidApplication = appguid;
  while((hr = lpDP3A->EnumSessions(&sessionDesc, 2500, EnumSessionsCallback,
                                    NULL,DPENUMSESSIONS_ASYNC))!= DP_OK){
    if((hr == DPERR_CONNECTING) || (hr == DPERR_GENERIC) || (hr == DPERR_USERCANCEL)){
      break;
    }
  }

  if(somanypeople)
    BackStrList->Add(" ----- ȏ񋓂܂ ----- ");
  if((!FirstEnum) && (SessionCount == 0)){
    BackStrList->Clear();
    BackStrList->Add(" -----  ܂͒N܂  ----- ");
    OKBtn->Enabled = false;
  }

  BackStrList->EndUpdate();
  ListBox1->Items = BackStrList;
  FirstEnum = false;
  MustStopAsync = true;
}
//---------------------------------------------------------------------------
BOOL CALLBACK EnumSessionsCallback(LPCDPSESSIONDESC2 lpSessionDesc,
            LPDWORD lpdwTimeOut, DWORD dwFlags, LPVOID lpContext)
{
  //ZbV̂тɌĂяoR[obN֐
  if(dwFlags & DPESC_TIMEDOUT){                // [Time out]
    return FALSE;
  }else if(SeDlg->SessionCount >= SeDlg->MAXPlayer){  // [over population]
    SeDlg->somanypeople = true;
    return FALSE;
  }

  if(SeDlg->FirstEnum){
    SeDlg->ListBox1->Clear();
  }else{
    SeDlg->GuidList[SeDlg->SessionCount] = lpSessionDesc->guidInstance;
    SeDlg->BackStrList->Add("E " + (AnsiString)(lpSessionDesc->lpszSessionNameA));

    SeDlg->SessionCount++;
  }
  return TRUE;
}
//---------------------------------------------------------------------------
void __fastcall TSeDlg::CancelBtnClick(TObject *Sender)
{
  Timer1->Enabled = false;
  ModalResult = 3;
}
//---------------------------------------------------------------------------
void __fastcall TSeDlg::ListBox1Click(TObject *Sender)
{
  //   ̃ZbVȈ
  if(ListBox1->ItemIndex >= SessionCount || ListBox1->ItemIndex == -1){
    ListBox1->ItemIndex = -1;
    return;
  }

  BtnNew->Default = false;
  OKBtn->Enabled = true;
  OKBtn->Default = true;
  selectedGuid = GuidList[ListBox1->ItemIndex];
}
//---------------------------------------------------------------------------
int TSeDlg::myOpen(bool create)
{
  //  ZbVJi܃G[j
  HRESULT hr;
  DWORD   howtoopen;

  memset(&sessionDesc, 0, sizeof(DPSESSIONDESC2));
  sessionDesc.dwSize = sizeof(DPSESSIONDESC2);

  if(create){  //   VKZbV쐬{^NbNƂ̏
    sessionDesc.dwFlags = DPSESSION_MIGRATEHOST | DPSESSION_NOMESSAGEID;// | DPSESSION_KEEPALIVE;
    sessionDesc.guidApplication = appguid;
    sessionDesc.dwMaxPlayers = 2;
    sessionDesc.lpszSessionNameA = myname.c_str();
    howtoopen = DPOPEN_CREATE;
  }else{       //   ̃ZbVȈ
    sessionDesc.guidInstance = GuidList[ListBox1->ItemIndex];
    howtoopen = DPOPEN_JOIN;
  }
  
  //  DPERR_CONNECTING ΍ADP_OKÃG[o܂ŉ񂵂ÂB
  while((hr = lpDP3A->Open(&sessionDesc, howtoopen)) != DP_OK){
    if(hr==DPERR_ALREADYINITIALIZED){  // oȂ͂
      MessageBox(SeDlg->Handle, "ɊJꂽZbVB",
            "vC[܂", MB_OK | MB_ICONWARNING);
      break;
    }else if(hr==DPERR_CONNECTING){  //ڑ(_CAAbv)܂ł܂킵B
      Sleep(500);
      continue;
    }else if(hr==DPERR_NOCONNECTION){  //ȂB
      MessageBox(SeDlg->Handle, "ʐMNmĂ܂B",
            "vC[܂", MB_OK | MB_ICONWARNING);
      break;
    }else if(hr==DPERR_TIMEOUT){    //TCP/IP, IPXő肪BuOpenŌł܂Ă܂v
      MessageBox(SeDlg->Handle, "^CAEg܂Bł܂Ă߂ˁB\nIvC[AĂ܂A\ñvC[Ǝn߂Ă܂\܂B",
            "vC[܂", MB_OK | MB_ICONWARNING);
      return -1;
    }else if(hr==DPERR_USERCANCEL){
      break;
    }else if(hr==DPERR4_CANNOTCREATESERVER){ //IDirectPlay4̃G[ //IPXŃ[JzXgQ{Ă
      MessageBox(SeDlg->Handle, "̃T[rXvoC_[́ÃT[o\nȏ̃zXgvC[܂",
            "G[: Q[Jnł܂B", MB_OK | MB_ICONWARNING);
      return -1;
    }else if(hr==DPERR4_CONNECTIONLOST){     //IDirectPlay4̃G[ //TCP/IPő肪
      MessageBox(SeDlg->Handle, "ZbVƂ̐ڑ܂B\n͑IvC[AĂ܂A\ñvC[Ǝn߂Ă܂\܂B",
            "G[: Q[Jnł܂B", MB_OK | MB_ICONWARNING);
      return -1;
    }else{ //[U[̃^CDirectX5̎͏QɏWB
      MessageBox(SeDlg->Handle, "s̃G[łB\ñvC[͋AĂ܂A\ñvC[ƃQ[n߂Ă܂\܂B",
            "G[: Q[Jnł܂B", MB_OK | MB_ICONWARNING);
      return -1;
    }
  }
  MustStopAsync = false;

  if(hr == DP_OK){
    tuduku = true;
    if(create)    return 1;
    else          return 2;
  }else{
    return 3;
  }
}
//---------------------------------------------------------------------------
void __fastcall TSeDlg::FormDestroy(TObject *Sender)
{
  delete BackStrList;
  GlobalFree(GuidList);
}
//---------------------------------------------------------------------------
void __fastcall TSeDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
  Timer1->Enabled = false;

  if(MustStopAsync){
    memset(&sessionDesc, 0, sizeof(DPSESSIONDESC2));
    sessionDesc.dwSize = sizeof(DPSESSIONDESC2);
    lpDP3A->EnumSessions(&sessionDesc, 0, EnumSessionsCallback,NULL,DPENUMSESSIONS_STOPASYNC);
  }
  if(!tuduku)  ModalResult = 3;     // [~]ꂽ̂߁B
}
//---------------------------------------------------------------------------
void __fastcall TSeDlg::FormShow(TObject *Sender)
{
  Edit1->SetFocus();
}
//---------------------------------------------------------------------------

