//----------------------------------------------------------------------------
#ifndef SDlgH
#define SDlgH
//----------------------------------------------------------------------------
#define IDIRECTPLAY2_OR_GREATER
#include <Classes.hpp>
#include <Controls.hpp>
#include <ExtCtrls.hpp>
#include <StdCtrls.hpp>
#include "dplay.h"

#ifndef PACKAGE
  #define PACKAGE
#endif
//----------------------------------------------------------------------------
class TSeDlg : public TForm
{
__published:
  TListBox *ListBox1;
  TEdit *Edit1;
  TLabel *Label1;
  TButton *CancelBtn;
  TButton *OKBtn;
  TButton *BtnNew;
  TButton *BtnEnum;
  TTimer *Timer1;
  void __fastcall CancelBtnClick(TObject *Sender);
  void __fastcall ListBox1Click(TObject *Sender);
  void __fastcall BtnNewClick(TObject *Sender);
  void __fastcall OKBtnClick(TObject *Sender);
  void __fastcall FormDestroy(TObject *Sender);
  void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
  void __fastcall Timer1Timer(TObject *Sender);
  void __fastcall BtnEnumClick(TObject *Sender);
  void __fastcall FormShow(TObject *Sender);

private:
  int myOpen(bool create);
  void enumulate();
  friend BOOL CALLBACK EnumSessionsCallback(LPCDPSESSIONDESC2 lpSessionDesc,
              LPDWORD lpdwTimeOut, DWORD dwFlags, LPVOID lpContext);

  LPDIRECTPLAY3A lpDP3A;
  GUID appguid, selectedGuid;
  GUID* GuidList;
  DPSESSIONDESC2 sessionDesc;
  int MAXPlayer, SessionCount;
  bool tuduku, somanypeople, FirstEnum, RunInTimer, MustStopAsync;
  AnsiString myname;
  TStringList *BackStrList;
  
public:
  __fastcall TSeDlg(TComponent* AOwner, LPDIRECTPLAY3A lpDP,
                GUID appGuid, unsigned MaxPlayers, unsigned MaxNameLen);
  AnsiString GetPlayerName() { return myname; };
};
//----------------------------------------------------------------------------
extern PACKAGE TSeDlg *SeDlg;
//----------------------------------------------------------------------------
#endif
