/***************************************************************************/
/**                        TMan2Man main unit                             **/
/***************************************************************************/

#include <vcl.h>
#pragma hdrstop

#include "Man2Man.h"
#if __BCPLUSPLUS__ != 0x0520
#pragma package(smart_init)
#endif
//---------------------------------------------------------------------------
#define GUARANTEEDMESSAGE   3333
#define GUARANTEEDACK       7777
#define RECOVERYACK         9999
#define MV_REGIDATA   100
#define MV_FREEDATA   101
#define MV_CHAT       102
#define MV_LIVECHECK  103
#define MV_RECOVERY   104
//---------------------------------------------------------------------------
// ValidCtrCheck ͍쐬ꂽR|[lgz֐ȂƂ
// ۏ؂邽߂Ɏgp܂B
//
static inline void ValidCtrCheck(TMan2Man *)
{
  new TMan2Man(NULL);
}
//R|[lgo^֐-----------------------------------------------------
namespace Man2man
{
  void __fastcall PACKAGE Register()
  {
    TComponentClass classes[1] = {__classid(TMan2Man)};
    RegisterComponents("Samples", classes, 0);
  }
}
//---------------------------------------------------------------------------
__fastcall TMan2Man::TMan2Man(TComponent* Owner)
  : TComponent(Owner)
{
  InitDP = FIsConnection = false;
  SelectedConnection = -1;
  
  MasterName = "Master";
  MaxEnumPlayers = 10;
  LiveCheckInterval = 3000;
  OldPlayersName = "";
  csender = NULL;

  InitDataPool();
}
//---------------------------------------------------------------------------
__fastcall TMan2Man::~TMan2Man()
{
  UnInitDirectPlay();
  UnInitDataPool();
}
//---------------------------------------------------------------------------
bool __fastcall TMan2Man::InitDirectPlay()
{
  if(!InitDP){
    CoInitialize(NULL);

    HRESULT hr = CoCreateInstance(CLSID_DirectPlay,NULL,CLSCTX_INPROC_SERVER,
                                     IID_IDirectPlay3A,(LPVOID *)&lpDP3A);
    if(FAILED(hr)){
      if(hr == E_NOINTERFACE)
        Application->MessageBox("ʐM@\gɂDirectX5ȏオKvłB",
                "G[F DirectPlayg܂", MB_OK | MB_ICONERROR);
      return false;
    }
    
    hReceiveEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
    hAckEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
    hRecoveryEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
    hCheckerEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
    receiver = new ReceiveThread(true,hReceiveEvent,hAckEvent,hRecoveryEvent,
                      lpDP3A,(TThreadMethod)&SelectData2,&rcvd);  // MXbh̍쐬
    csender = new CheckSenderThread(true,(TThreadMethod)&SendLiveChecker,hCheckerEvent);
    csender->SetInterval(FLiveCheckInterval);

    AliveTimer = new TTimer(this);
    AliveTimer->Enabled = false;
    AliveTimer->OnTimer = AliveTimerTimer;

    InitDP = true;
  }
  return true;
}
//---------------------------------------------------------------------------
void __fastcall TMan2Man::UnInitDirectPlay()
{
  if(InitDP){
    delete AliveTimer;
    AliveTimer = NULL;
    
    receiver->Terminate();
    csender->Terminate();
    SetEvent(hCheckerEvent);
    SetEvent(hReceiveEvent);
    delete receiver;
    delete csender;
    csender = NULL;

    CloseHandle(hCheckerEvent);
    CloseHandle(hRecoveryEvent);
    CloseHandle(hAckEvent);
    CloseHandle(hReceiveEvent);
    lpDP3A->Close();
    lpDP3A->Release();
    CoUninitialize();
    InitDP = false;
  }
}
//---------------------------------------------------------------------------
bool __fastcall TMan2Man::LetsConnect(GUID appGuid) //public
{
  //  ڑ̊֐BCDlg,SDlg,ĂсASessionPlayerB
  int rh1, rh2;

  appguid = appGuid;

  if(IsConnection)      return true;
  if(!InitDirectPlay()) return false;

  //   ڑ_CAO(CDlg)̕\
  CoDlg = new TCoDlg(Owner,lpDP3A,appguid,SelectedConnection);
  rh1 = CoDlg->ShowModal();
  SelectedConnection = CoDlg->ComboBox1->ItemIndex;
  delete CoDlg;

  if(rh1 == 1){    //   ڑmƂ
    //   ZbV_CAO(SDlg)\
    SeDlg = new TSeDlg(Owner,lpDP3A,appguid,MaxEnumPlayers,MaxNameLength);
    SeDlg->Edit1->Text = OldPlayersName;
    rh2 = SeDlg->ShowModal();
    OldPlayersName = SeDlg->Edit1->Text;
    player[0].name = SeDlg->GetPlayerName();
    delete SeDlg;

    GetProviderCaps();

    if(rh2 == 1){      //   VKzXgvC[쐬
      if(!CPlayer(1))  return false;
      MakeChatBox(EV_ENTERROOM,MYPLAYER,"");
      return true;
    }
    else if(rh2 == 2){ //   VKNCAgvC[쐬
      if(!CPlayer(2))  return false;
      //MakeChatBox(EV_ENTERROOM,MYPLAYER,"");

      AliveTimer->Enabled = true;
      AliveTimer->Interval = LiveCheckInterval*2;

      GuaranteedCounter = 0;
      receiver->SetPlayersID(player[0].dpid, player[1].dpid);
      csender->Resume();

      FIsConnection = true;
      LostConnection = false;

      if(OnGuestArrived) OnGuestArrived(this,false);
      MakeChatBox(EV_ENTERROOM,MYPLAYER,"");

      return true;
    }
  }
  UnInitDirectPlay();
  return false;
}
//---------------------------------------------------------------------------
void __fastcall TMan2Man::Disconnect() //public
{
  // ZbVijB
  if(InitDP){
    player[0].dpid = player[1].dpid = 0;
    player[0].name = player[1].name = "";

    FIsConnection = false;
    AliveTimer->Enabled = false;

    MakeChatBox(EV_EXITROOM,MYPLAYER,"");
    if(OnGuestLalabye) OnGuestLalabye(this);
    
    UnInitDirectPlay();
  }
}
//---------------------------------------------------------------------------
bool __fastcall TMan2Man::CPlayer(int kind)
{
  // PlayerBkind=1 :zXgBkind=2 :NCAgB

  HRESULT hr;
  DPID dpidPlayer = NULL;
  DPNAME dpName;

  for(int i=0;i<2;i++){  //dpid 
    player[i].dpid = 0;
  }
  memset(&dpName, 0, sizeof(DPNAME));
  dpName.dwSize = sizeof(DPNAME);
  dpName.lpszShortNameA = player[0].name.c_str();
  dpName.lpszLongNameA = NULL;

  hr = lpDP3A->CreatePlayer(&dpidPlayer, &dpName, hReceiveEvent, NULL, 0, 0);
  if(hr!=DP_OK){
    return false;
  }else{
    player[0].dpid = dpidPlayer;
  }

  if(kind==2){ // vC[݂ɎQȂ羯ݒɂق̃vC[T
    hr = lpDP3A->EnumPlayers(NULL,EnumPlayersCB,this,DPENUMPLAYERS_ALL);
    if(FAILED(hr))  return false;
  }

  //   MXbh𓮂
  receiver->Resume();
  return true;
}
//---------------------------------------------------------------------------
bool __fastcall TMan2Man::RenewalSession()
{
  // ClientHostɂȂAZbVςB
  DPSESSIONDESC2 sessionDesc;
  HRESULT hr;

  memset(&sessionDesc, 0, sizeof(DPSESSIONDESC2));
  sessionDesc.dwSize = sizeof(DPSESSIONDESC2);

  sessionDesc.dwFlags = DPSESSION_MIGRATEHOST | DPSESSION_NOMESSAGEID;// | DPSESSION_KEEPALIVE;
  sessionDesc.guidApplication = appguid;
  sessionDesc.dwMaxPlayers = 2;
  sessionDesc.lpszSessionNameA = player[0].name.c_str();

  hr = lpDP3A->SetSessionDesc(&sessionDesc,0);

  if(SUCCEEDED(hr))   return true;
  else                return false;
}
//---------------------------------------------------------------------------
BOOL CALLBACK EnumPlayersCB(DPID dpid,DWORD dwPlayerType,LPCDPNAME lpName,
                            DWORD dwFlags,LPVOID man2)
{
  // ZbVɎQĂvC[邽тɌĂяoR[obN֐
  ((TMan2Man*)man2)->player[1].dpid = dpid;
  ((TMan2Man*)man2)->player[1].name = lpName->lpszShortNameA;

  return TRUE;
}
//---------------------------------------------------------------------------
//{M
//---------------------------------------------------------------------------
bool __fastcall TMan2Man::MySend(LPVOID lpData, DWORD dwDataSize, bool Guaranty)
{
  HRESULT hr;

  if(!Guaranty){   //ۏؖ
    hr = lpDP3A->Send(player[0].dpid, player[1].dpid, 0, lpData, dwDataSize);

  }else{           //ۏؗL
    if(PCaps.GuaranteedSupported){ //T[rXvoC_ۏؒʐMT|[gĂB
      hr = lpDP3A->Send(player[0].dpid, player[1].dpid, DPSEND_GUARANTEED, lpData, dwDataSize);

    }else{                         //T[rXvoC_ۏؒʐMT|[gĂȂB
      unsigned TotalSize = dwDataSize + sizeof(DWORD)*2;

      if(!ResizeDataPool(0,TotalSize)) return false;
      LPMYMSG_HEADER GuaranteedMsg = pool.pData[0];

      GuaranteedMsg->dwType = GUARANTEEDMESSAGE;
      GuaranteedMsg->dwNumber = GuaranteedCounter;
      memcpy(&GuaranteedMsg->DataTop, lpData, dwDataSize);

      for(int i=0;i<10;i++){
        hr = lpDP3A->Send(player[0].dpid, player[1].dpid, 0, (void*)GuaranteedMsg, TotalSize);

        if(SUCCEEDED(hr))   // ACKԂ܂ő~߁BPCaps.Timeout 炢o߂ƎsB
          if((WaitForSingleObject(hAckEvent,PCaps.Timeout/12)) == WAIT_OBJECT_0) break;

        if(i==9)  return false;
      }
      GuaranteedCounter++;
    }
  }
  if(FAILED(hr)){
    SendError(hr);
    return false;
  }else{
    SomethingSent();
    return true;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMan2Man::SelectData2()
{
  //receiverXbhĂ΂āAĂdataeɂ菈𕪂֐B

  if(rcvd.idFrom == DPID_SYSMSG){  //VXebZ[W
    switch (rcvd.lpMsgBuffer->dwType) {
    case DPSYS_CREATEPLAYERORGROUP: {
      //[U[ꂽ
      LPDPMSG_CREATEPLAYERORGROUP lpcplayer = (LPDPMSG_CREATEPLAYERORGROUP)rcvd.lpMsgBuffer;

      player[1].dpid = lpcplayer->dpId;
      player[1].name = lpcplayer->dpnName.lpszShortNameA;

      //MakeChatBox(EV_ENTERROOM,YOURPLAYER,"");
      FIsConnection = true;
      LostConnection = false;

      AliveTimer->Enabled = true;
      AliveTimer->Interval = LiveCheckInterval*2;
      SomethingReceived();

      GuaranteedCounter = 0;
      receiver->SetPlayersID(player[0].dpid, player[1].dpid);
      csender->Resume();

      if(OnGuestArrived) OnGuestArrived(this,true);
      MakeChatBox(EV_ENTERROOM,YOURPLAYER,"");
      
      break;
      }
    case DPSYS_DESTROYPLAYERORGROUP: {
      //[U[...ZbV
      MakeChatBox(EV_EXITROOM,YOURPLAYER,"");

      player[1].dpid = 0;
      player[1].name = "";

      FIsConnection = false;
      AliveTimer->Enabled = false;
      csender->Suspend();
      if(OnGuestLalabye) OnGuestLalabye(this);

      break;
      }
    case DPSYS_HOST: {
      //zXgăZbVύX
      if(!RenewalSession())  Disconnect();
      break;
      }
    case DPSYS_SESSIONLOST: {
      //T[rXvoC_Ƃ̐ڑꂽB
      AliveTimer->Enabled = false;
      LostConnection = true;
      if(OnLostConnection)  OnLostConnection(this);
      if(LostConnection)    Disconnect();
      break;
      }
    }
  }else{   //AvP[V̓Ǝ̃bZ[W
    SomethingReceived();
    
    switch (rcvd.lpMsgBuffer->dwType){
    case MV_REGIDATA:
      RegiDataGet(rcvd.lpMsgBuffer); break;
    case MV_FREEDATA:
      FreeDataGet(rcvd.lpMsgBuffer); break;
    case MV_CHAT:
      ChatGet(rcvd.lpMsgBuffer); break;
    case MV_LIVECHECK:
      break; // ȂB
    }
  }
}
//---------------------------------------------------------------------------
//Lf[^֘A(CommonData)
//---------------------------------------------------------------------------
RegiDataTag __fastcall TMan2Man::RegiStruct(void* pData, unsigned size, unsigned ID) //public
{
  for(int i=0;i<(signed)CD.pData.size();i++){
    if(ID == CD.id[i]){
      if(pData == CD.pData[i] && size == CD.size[i]) return i;
      else
        throw Exception("TMan2ManR|[lgŗO܂B\nRegiStructɓID̍\̂o^Ă܂B");
    }
  }
  if((CD.pData.size()%10)==0){
    CD.pData.reserve(CD.pData.size()+10);
    CD.size.reserve(CD.size.size()+10);
    CD.id.reserve(CD.id.size()+10);
  }
  CD.pData.push_back(pData);
  CD.size.push_back(size);
  CD.id.push_back(ID);

  ResizeDataPool(1, sizeof(DWORD)*2 + size);

  return CD.pData.size() - 1;
}
//---------------------------------------------------------------------------
bool __fastcall TMan2Man::SendRegiData(RegiDataTag DataTag, bool Guaranty) //public
{
  //Lf[^𑗐M֐B
  if(!IsConnection || LostConnection)             return false;  // ݃N܂Ȃ甲
  if(DataTag<0||(signed)CD.pData.size()<=DataTag) return false;  // DataTagU

  LPMYMSG_HEADER Regi = pool.pData[1];

  Regi->dwType = MV_REGIDATA;
  Regi->dwNumber = CD.id[DataTag];

  memcpy(&Regi->DataTop, CD.pData[DataTag], CD.size[DataTag]);

  return MySend(Regi, sizeof(DWORD)*2 + CD.size[DataTag], Guaranty);
}
//---------------------------------------------------------------------------
void __fastcall TMan2Man::RegiDataGet(LPDPMSG_GENERIC lpMsgBuffer)
{
  LPMYMSG_HEADER Common = (LPMYMSG_HEADER)lpMsgBuffer;

  for(int i=0;i<(signed)CD.pData.size();i++){
    if(CD.id[i] == Common->dwNumber){
      memcpy(CD.pData[i], &(Common->DataTop), CD.size[i]);

      if(OnRegiDataComming) OnRegiDataComming(this,i);
      return;
    }
  }
  throw Exception("TMan2ManR|[lgŗO܂B\no^f[^͂܂BData ID = " + Common->dwNumber);
}
//---------------------------------------------------------------------------
//R`f[^(FreeData)
//---------------------------------------------------------------------------
bool __fastcall TMan2Man::SendFreeData(void* pData, unsigned size, bool Guaranty) //public
{
  unsigned TotalSize = sizeof(DWORD)*2 + size;

  if(!IsConnection || LostConnection)  return false;  // ݃N܂Ȃ甲
  if(pData==NULL || size==0)           return false;

  if(!ResizeDataPool(2,TotalSize)) return false;
  LPMYMSG_HEADER Free = pool.pData[2];

  Free->dwType = MV_FREEDATA;
  Free->dwSize = size;

  memcpy(&Free->DataTop, pData, size);

  return MySend(Free, TotalSize, Guaranty);
}
//---------------------------------------------------------------------------
void __fastcall TMan2Man::FreeDataGet(LPDPMSG_GENERIC lpMsgBuffer)
{
  LPMYMSG_HEADER Free = (LPMYMSG_HEADER)lpMsgBuffer;

  if(OnFreeDataComming) OnFreeDataComming(this,&Free->DataTop,Free->dwSize);
}
//---------------------------------------------------------------------------
//`bg舵n(Chat)
//---------------------------------------------------------------------------
bool __fastcall TMan2Man::SendChat(AnsiString Msg) //public
{
  //   `bgM֐
  unsigned MsgLen = Msg.Length() + sizeof('\0');
  unsigned TotalLen = sizeof(DWORD)*2 + MsgLen;

  if(!IsConnection || LostConnection)  return false;   // ݃N܂Ȃ甲B
  if(MsgLen == 1)                      return true;    // NULLȂ瑗ȂB

  if(!ResizeDataPool(3,TotalLen)) return false;
  LPMYMSG_HEADER Chat = pool.pData[3];

  Chat->dwType = MV_CHAT;
  Chat->dwSize = TotalLen;
  memcpy(&Chat->DataTop, Msg.c_str(), MsgLen);

  bool Result = MySend(Chat, TotalLen, true); //`bg͕ۏ(since ver2.3)

  if(Result) MakeChatBox(EV_CHAT,MYPLAYER,Msg);

  return Result;
}
//---------------------------------------------------------------------------
void __fastcall TMan2Man::ChatGet(LPDPMSG_GENERIC lpMsgBuffer)
{
  //  `bgf[^󂯎Ƃ̏
  LPMYMSG_HEADER Chat = (LPMYMSG_HEADER)lpMsgBuffer;

  MakeChatBox(EV_CHAT,YOURPLAYER,(char*)&Chat->DataTop);
}
//---------------------------------------------------------------------------
void __fastcall TMan2Man::MakeChatBox(ChatEvent event, WhoIs whois, AnsiString word)
{
  // chatbox Ƀf[^AOnChatComming ĂԁB

  if((event == EV_CHAT)&&(word.Length() == 0))
    return;

  chatbox.event = event;
  chatbox.whois = whois;
  chatbox.namaMsg = word;

  //ReadChat()œ镶B
  switch(event){
  case EV_ENTERROOM:
    if(whois==MYPLAYER)
      chatbox.kakouMsg = MasterName + " >> 悤A" + GetPlayerName(whois) + "B";
    if(whois==YOURPLAYER)
      chatbox.kakouMsg = MasterName + " >> " + GetPlayerName(whois) + "񂪗܂B";
    break;
  case EV_EXITROOM:
    if(whois==MYPLAYER)
      chatbox.kakouMsg = MasterName + " >> ܂ĂˁB";
    if(whois==YOURPLAYER)
      chatbox.kakouMsg = MasterName + " >> " + GetPlayerName(whois) + "񂪋A܂B";
    break;
  case EV_CHAT:
    chatbox.kakouMsg = GetPlayerName(whois) + " > " + word;
    break;
  }

  if(OnChatComming) OnChatComming(this);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMan2Man::ReadChat() //public
{
  return chatbox.kakouMsg;
}
//---------------------------------------------------------------------------
void __fastcall TMan2Man::ReadChatEx(ChatEvent &event, WhoIs &whois, AnsiString &namaMsg) //public
{
  event   = chatbox.event;
  whois   = chatbox.whois;
  namaMsg = chatbox.namaMsg;
}
//---------------------------------------------------------------------------
//N`FbNn(LiveChecker)
//---------------------------------------------------------------------------
bool __fastcall TMan2Man::SendLiveChecker()
{
  MYMSG_HEADER Alive;
  Alive.dwType = MV_LIVECHECK;
  Alive.dwNumber = 0;

  return MySend((void*)&Alive, sizeof(Alive), false);  //ۏ
}
//---------------------------------------------------------------------------
void __fastcall TMan2Man::SomethingReceived()
{
  AliveTimer->Enabled = false;
  AliveTimer->Interval = LiveCheckInterval*2 + PCaps.Timeout;

  if(LiveCheckInterval != 0)AliveTimer->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TMan2Man::SomethingSent()
{
  SetEvent(hCheckerEvent);
}
//---------------------------------------------------------------------------
void __fastcall TMan2Man::AliveTimerTimer(TObject *Sender)
{
  AliveTimer->Enabled = false;
  LostConnection = true;
  if(OnLostConnection)  OnLostConnection(this);
  if(LostConnection)    Disconnect();
}
//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
bool __fastcall TMan2Man::RecoverConnection(unsigned Timeout) //public
{
  if(!LostConnection || !IsConnection) return false;

  ResetEvent(hRecoveryEvent);

  ReDlg = new TReDlg(Application,(TThreadMethod)&SendRecoveryChecker,hRecoveryEvent,Timeout);
  int mr = ReDlg->ShowModal();
  delete ReDlg;

  if(mr == mrOk){
    LostConnection = false;
    AliveTimer->Enabled = true;
    SomethingReceived();
    return true;
  }else{
    return false;
  }
}
//---------------------------------------------------------------------------
bool __fastcall TMan2Man::SendRecoveryChecker()
{
  MYMSG_HEADER Recovery;
  Recovery.dwType = MV_RECOVERY;
  Recovery.dwNumber = 0;

  return MySend((void*)&Recovery, sizeof(Recovery), false);  //ۏ
}
//---------------------------------------------------------------------------
//f[^v[
//---------------------------------------------------------------------------
void __fastcall TMan2Man::InitDataPool()
{
  for(int i=0;i<4;i++){
    pool.size[i] = 0;
    pool.pData[i] = NULL;
  }
}
//---------------------------------------------------------------------------
bool __fastcall TMan2Man::ResizeDataPool(int Num, unsigned size)
{
  if(pool.size[Num] >= size)   return true;
  unsigned biggersize = (1 + size/100)*100;

  if(pool.pData[Num] != NULL) GlobalFree(pool.pData[Num]);
  pool.pData[Num] = (LPMYMSG_HEADER)GlobalAlloc(GPTR, biggersize);

  if(pool.pData[Num] == NULL){
    pool.size[Num] = 0;
    return false;
  }else{
    pool.size[Num] = biggersize;
    return true;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMan2Man::UnInitDataPool()
{
  for(int i=0;i<4;i++)
    if(pool.pData[i] != NULL)
      GlobalFree(pool.pData[i]);
}
//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
AnsiString __fastcall TMan2Man::GetPlayerName(WhoIs who) //public
{
  switch(who){
  case MYPLAYER:   return player[0].name;
  case YOURPLAYER: return player[1].name;
  case GAMEMASTER: return FMasterName;
  default:         return "";
  }
}
//---------------------------------------------------------------------------
void __fastcall TMan2Man::SetMaxEnumPlayers(int Value)
{
  if(Value<1)         FMaxEnumPlayers = 1;
  else if(Value>100)  FMaxEnumPlayers = 100;
  else                FMaxEnumPlayers = Value;
}
//---------------------------------------------------------------------------
void __fastcall TMan2Man::SetMaxNameLength(int Value)
{
  if(Value<0)         FMaxNameLength = 0;
  else if(Value>200)  FMaxNameLength = 200;
  else                FMaxNameLength = Value;
}
//---------------------------------------------------------------------------
void __fastcall TMan2Man::SetLiveCheckInterval(int Value)
{
  if(Value == 0)        FLiveCheckInterval = 0;       //CxgB
  else if(Value<500)    FLiveCheckInterval = 500;     //ŒZ0.5b
  else if(Value>10000)  FLiveCheckInterval = 10000;   //Œ10b
  else                  FLiveCheckInterval = Value;

  if(csender)   csender->SetInterval(FLiveCheckInterval);
  if(AliveTimer && AliveTimer->Enabled){
    AliveTimer->Enabled = false;
    AliveTimer->Interval = FLiveCheckInterval;
    AliveTimer->Enabled = true;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMan2Man::SetMasterName(AnsiString Value)
{
  if((Value.Trim()).Length()==0)  return;
  FMasterName = Value.SubString(1,10);
}
//---------------------------------------------------------------------------
void __fastcall TMan2Man::SendError(HRESULT hr)
{
  AnsiString errstr1, errstr2 = "G[F@f[^̑Mo܂łB";

  if(hr==DPERR_BUSY)
    errstr1 = "f[^̑Mo܂łB\nrW[ɂȂĂ܂B";
  else if(hr==DPERR_SENDTOOBIG)
    errstr1 = "f[^̑Mo܂łB\nf[^傫܂B";
  else
    return;

  Application->MessageBox(errstr1.c_str(), errstr2.c_str(), MB_OK | MB_ICONEXCLAMATION);
}
//---------------------------------------------------------------------------
void __fastcall TMan2Man::GetProviderCaps()
{
  DPCAPS dpcaps;
  dpcaps.dwSize = sizeof(DPCAPS);

  lpDP3A->GetCaps(&dpcaps,0);

  PCaps.GuaranteedSupported = dpcaps.dwFlags & DPCAPS_GUARANTEEDSUPPORTED;
  PCaps.KeepAliveSupported  = dpcaps.dwFlags & DPCAPS_KEEPALIVEOPTIMIZED;
  PCaps.Latency             = dpcaps.dwLatency;
  PCaps.Timeout             = dpcaps.dwTimeout;
}
//---------------------------------------------------------------------------
//MXbh(ReceiveThread)
//---------------------------------------------------------------------------
__fastcall ReceiveThread::ReceiveThread(bool CreateSuspended,
                        HANDLE hReEvent, HANDLE hAEvent, HANDLE hRcEvent,
                        LPDIRECTPLAY3A lpDP, TThreadMethod Select2, ReceivedData* rcvd)
    : TThread(CreateSuspended)
{
  Priority = tpTimeCritical;
  hReceiveEvent = hReEvent;
  hAckEvent = hAEvent;
  hRecoveryEvent = hRcEvent;
  lpDP3A = lpDP;
  SelectData2 = Select2;
  prcvd = rcvd;
  lpMsgBuffer = NULL;
  dwMsgBufferSize = 0;
}
//---------------------------------------------------------------------------
__fastcall ReceiveThread::~ReceiveThread()
{
  if(lpMsgBuffer!=NULL)   GlobalFree(lpMsgBuffer);
}
//---------------------------------------------------------------------------
void __fastcall ReceiveThread::SetPlayersID(DPID mine, DPID yours)
{
  MyGuaranteedCounter = YourGuaranteedCounter = 0;
  MyID = mine;
  YourID = yours;
}
//---------------------------------------------------------------------------
void __fastcall ReceiveThread::Execute()
{
  while(WaitForSingleObject(hReceiveEvent,INFINITE) == WAIT_OBJECT_0){
    if(Terminated==true)  return;

    SelectData();
  }
}
//---------------------------------------------------------------------------
void __fastcall ReceiveThread::SelectData()
{
  //Ădataɏ𕪂֐B̂PBۏ؃bZ[WƂACKoB
  DPID idFrom, idTo;
  HRESULT hr;
  LPDPMSG_GENERIC lpNoGraBuffer;

  //bZ[W̎o
  do{
  loopback:
    hr = lpDP3A->Receive(&idFrom, &idTo, DPRECEIVE_ALL, lpMsgBuffer, &dwMsgBufferSize);

    if(hr == DPERR_BUFFERTOOSMALL){
      if(lpMsgBuffer != NULL)   GlobalFree(lpMsgBuffer);

      lpMsgBuffer = (LPDPMSG_GENERIC)GlobalAlloc(GPTR, dwMsgBufferSize);

      if(lpMsgBuffer == NULL)   hr = DPERR_OUTOFMEMORY;
      else                      goto loopback;
    }

    if(SUCCEEDED(hr)){  //bZ[W̎擾ɐ
      if((idFrom != DPID_SYSMSG) && (lpMsgBuffer->dwType == GUARANTEEDMESSAGE)){
        //TMan2ManƎ̕ۏ؃bZ[W
        LPMYMSG_HEADER pReceived = (LPMYMSG_HEADER)lpMsgBuffer;
        MYMSG_HEADER ack;

        ack.dwType = GUARANTEEDACK;
        ack.dwNumber = pReceived->dwNumber;

        lpDP3A->Send(MyID, YourID, 0, (void*)&ack, sizeof(DWORD)*2); //ACKԂ

        if(pReceived->dwNumber < YourGuaranteedCounter) goto loopback;

        YourGuaranteedCounter = pReceived->dwNumber;
        lpNoGraBuffer = (LPDPMSG_GENERIC)&pReceived->DataTop;  //ۏ؊kE
      }else{
        lpNoGraBuffer = lpMsgBuffer;                           //EȂiĂȂj
      }

      if((idFrom != DPID_SYSMSG) && (lpMsgBuffer->dwType == MV_RECOVERY)){
        //񕜃bZ[W͂
        MYMSG_HEADER Recovery;
        SetEvent(hRecoveryEvent);

        Recovery.dwType = RECOVERYACK;
        Recovery.dwNumber = 0;
        lpDP3A->Send(MyID, YourID, 0, (void*)&Recovery, sizeof(DWORD)*2); //ACKԂ
      }else if((idFrom != DPID_SYSMSG) && (lpMsgBuffer->dwType == RECOVERYACK)){
        //񕜃bZ[WACKԂ
        SetEvent(hRecoveryEvent);
      }

      if((idFrom != DPID_SYSMSG) && (lpMsgBuffer->dwType == GUARANTEEDACK)){
        //ۏ؃bZ[WACKԂ
        LPMYMSG_HEADER ack = (LPMYMSG_HEADER)lpMsgBuffer;
        if(ack->dwNumber>=MyGuaranteedCounter){
          SetEvent(hAckEvent);   //ۏMySend̃ubN𔲂
          MyGuaranteedCounter++;
        }
      }else{
        //̃bZ[W̓CXbhɔCB
        prcvd->idFrom = idFrom;
        prcvd->lpMsgBuffer = lpNoGraBuffer;

        Synchronize((TThreadMethod)SelectData2);
      }
    }
  } while(SUCCEEDED(hr));
}
//---------------------------------------------------------------------------
//N`FbNMXbh(CheckSenderThread)
//---------------------------------------------------------------------------
__fastcall CheckSenderThread::CheckSenderThread(bool CreateSuspended,
                             TThreadMethod Send, HANDLE hEvent)
    : TThread(CreateSuspended)
{
  SendChecker = Send;
  hCheckerEvent = hEvent;
}
//---------------------------------------------------------------------------
void __fastcall CheckSenderThread::Execute()
{
  DWORD res;

  while(true){
    if(interval != 0) res = WaitForSingleObject(hCheckerEvent,interval);
    else              res = WaitForSingleObject(hCheckerEvent,INFINITE);
    if(Terminated==true)  return;

    if(res == WAIT_TIMEOUT)  SendChecker();
  }
}
//---------------------------------------------------------------------------
void __fastcall CheckSenderThread::SetInterval(int Interval)
{
  Suspend();
  interval = Interval;
  Resume();
  SetEvent(hCheckerEvent);
}
//---------------------------------------------------------------------------

