/****************************************************************************
**        TMan2Man R|[lg  Ver. 2.3       First Release 2000/6/15  **
**                          designed by achaboo   Last Update   2001/12/19 **
****************************************************************************/

#ifndef Man2ManH
#define Man2ManH
//---------------------------------------------------------------------------
#include <vector>
#include "M2CDlg.h"
#include "M2SDlg.h"
#include "M2RDlg.h"
#pragma link "M2CDlg.obj"
#pragma link "M2SDlg.obj"
#pragma link "M2RDlg.obj"
//---------------------------------------------------------------------------
#if __BCPLUSPLUS__ <= 0x0530
//DirectX5SDKgĂl͉̂Ps̃RgAEgOĂB------
  //#pragma link "dxguid.obj"

//̉ŃJG[oꍇ̓pX̐ݒ肪oĂ܂Binstall.txtQ
  #pragma comment(lib, "dplayx.lib")
  #pragma comment(lib, "dxguid.lib")
#endif
//---------------------------------------------------------------------------
typedef struct{   //XbhLϐ
  DWORD idFrom;
  LPDPMSG_GENERIC lpMsgBuffer;
}ReceivedData;

typedef struct{   //ėpʐMփb_[
  DWORD dwType;
  union {
    DWORD dwSize;
    DWORD dwNumber;
  };
  DWORD DataTop;
}MYMSG_HEADER, FAR *LPMYMSG_HEADER;
//---------------------------------------------------------------------------
typedef int RegiDataTag;

enum ChatEvent {EV_ENTERROOM, EV_EXITROOM, EV_CHAT};
enum WhoIs {MYPLAYER, YOURPLAYER, GAMEMASTER};

class ReceiveThread;
class CheckSenderThread;
class PACKAGE TMan2Man : public TComponent
{
  typedef void __fastcall (__closure *TRegiDataCommingEvent)(TObject *Sender, RegiDataTag DataTag);
  typedef void __fastcall (__closure *TFreeDataCommingEvent)(TObject *Sender, void* pData, unsigned size);
  typedef void __fastcall (__closure *TGuestArrivedEvent)(TObject *Sender, bool IsHost);

private:
  bool __fastcall InitDirectPlay();
  void __fastcall UnInitDirectPlay();
  bool __fastcall CPlayer(int kind);
  void __fastcall MakeChatBox(ChatEvent event,WhoIs whois, AnsiString word);
  bool __fastcall MySend(LPVOID lpData, DWORD dwDataSize, bool Guaranty);
  void __fastcall SelectData2();
  void __fastcall ChatGet(LPDPMSG_GENERIC lpMsgBuffer);
  void __fastcall RegiDataGet(LPDPMSG_GENERIC lpMsgBuffer);
  void __fastcall FreeDataGet(LPDPMSG_GENERIC lpMsgBuffer);
  void __fastcall SendError(HRESULT hr);
  bool __fastcall SendLiveChecker();
  bool __fastcall SendRecoveryChecker();
  void __fastcall SomethingReceived();
  void __fastcall SomethingSent();
  void __fastcall InitDataPool();
  bool __fastcall ResizeDataPool(int Num, unsigned size);
  void __fastcall UnInitDataPool();
  void __fastcall GetProviderCaps();
  bool __fastcall RenewalSession();
  
  void __fastcall SetMaxEnumPlayers(int Value);
  void __fastcall SetMaxNameLength(int Value);
  void __fastcall SetLiveCheckInterval(int Value);
  void __fastcall SetMasterName(AnsiString Value);

  void __fastcall AliveTimerTimer(TObject *Sender);

  friend BOOL CALLBACK EnumPlayersCB(DPID dpid,DWORD dwPlayerType,
                    LPCDPNAME lpName, DWORD dwFlags,LPVOID opContext);

  typedef struct{        //v[[vpeB
    DPID dpid;
    AnsiString name;
  } Player;

  struct ProviderCaps{   //T[rXvoC_[̔\
    bool GuaranteedSupported, KeepAliveSupported;
    int Latency, Timeout;
  } PCaps;

  struct CHATBOX{        //`bg
    ChatEvent event;
    WhoIs whois;
    AnsiString namaMsg, kakouMsg;
  }chatbox;

  struct CommonData{     //Lf[^
    std::vector<void*>    pData;
    std::vector<unsigned> size;
    std::vector<unsigned> id;
  }CD;

  struct DataPool{
    LPMYMSG_HEADER pData[4];
    unsigned size[4];
  }pool;
  
  LPDIRECTPLAY3A lpDP3A;
  HANDLE hReceiveEvent, hAckEvent, hRecoveryEvent, hCheckerEvent;
  bool InitDP, LostConnection;
  GUID appguid;
  Player player[2];
  ReceiveThread* receiver;
  CheckSenderThread* csender;
  TTimer* AliveTimer;
  DWORD GuaranteedCounter;
  ReceivedData rcvd;
  int SelectedConnection;
  AnsiString OldPlayersName;

  int FMaxNameLength, FMaxEnumPlayers, FLiveCheckInterval;
  bool FIsConnection;
  AnsiString FMasterName;
  TNotifyEvent FOnGuestLalabye, FOnChatComming, FOnLostConnection;
  TGuestArrivedEvent FOnGuestArrived;
  TRegiDataCommingEvent FOnRegiDataComming;
  TFreeDataCommingEvent FOnFreeDataComming;
public:
  __fastcall TMan2Man(TComponent* Owner);
  virtual __fastcall ~TMan2Man(void);
  bool __fastcall LetsConnect(GUID appGuid);
  void __fastcall Disconnect(void);
  AnsiString __fastcall GetPlayerName(WhoIs who);
  RegiDataTag __fastcall RegiStruct(void* pData, unsigned size, unsigned ID);
  bool __fastcall SendRegiData(RegiDataTag DataTag, bool Guaranty);
  bool __fastcall SendFreeData(void* pData, unsigned size, bool Guaranty);
  bool __fastcall SendChat(AnsiString Msg);
  AnsiString __fastcall ReadChat(void);
  void __fastcall ReadChatEx(ChatEvent &event, WhoIs &whois, AnsiString &namaMsg);
  bool __fastcall RecoverConnection(unsigned Timeout);
  
  __property bool IsConnection = {read=FIsConnection, nodefault};

__published:
  __property int MaxEnumPlayers = {read=FMaxEnumPlayers, write=SetMaxEnumPlayers, default=10};
  __property int MaxNameLength = {read=FMaxNameLength, write=SetMaxNameLength, default=0};
  __property int LiveCheckInterval = {read=FLiveCheckInterval, write=SetLiveCheckInterval, default=3000};
  __property AnsiString MasterName = {read=FMasterName, write=SetMasterName, nodefault};
  __property TGuestArrivedEvent OnGuestArrived = {read=FOnGuestArrived, write=FOnGuestArrived};
  __property TNotifyEvent OnGuestLalabye = {read=FOnGuestLalabye, write=FOnGuestLalabye};
  __property TNotifyEvent OnChatComming = {read=FOnChatComming, write=FOnChatComming};
  __property TRegiDataCommingEvent OnRegiDataComming = {read=FOnRegiDataComming, write=FOnRegiDataComming};
  __property TFreeDataCommingEvent OnFreeDataComming = {read=FOnFreeDataComming, write=FOnFreeDataComming};
  __property TNotifyEvent OnLostConnection = {read=FOnLostConnection, write=FOnLostConnection};
};
//----------------------------------------------------------------------------
class ReceiveThread : public TThread
{
private:
  HANDLE hReceiveEvent, hAckEvent, hRecoveryEvent;
  TThreadMethod SelectData2;
  LPDIRECTPLAY3A lpDP3A;
  ReceivedData* prcvd;
  LPDPMSG_GENERIC lpMsgBuffer;
  DWORD dwMsgBufferSize;
  DWORD MyGuaranteedCounter,YourGuaranteedCounter;
  DPID MyID, YourID;
protected:
  void __fastcall Execute();
  void __fastcall SelectData();
public:
  __fastcall ReceiveThread(bool CreateSuspended, HANDLE hReEvent, HANDLE hAEvent, HANDLE hRcEvent,
                LPDIRECTPLAY3A lpDP, TThreadMethod Select2, ReceivedData* rcvd);
  virtual __fastcall ~ReceiveThread();
  void __fastcall SetPlayersID(DPID mine, DPID yours);
};
//---------------------------------------------------------------------------
class CheckSenderThread : public TThread
{
private:
  TThreadMethod SendChecker;
  int interval;
  HANDLE hCheckerEvent;
protected:
  void __fastcall Execute();
public:
  __fastcall CheckSenderThread(bool CreateSuspended, TThreadMethod Send, HANDLE hEvent);
  void __fastcall SetInterval(int Interval);
};
//---------------------------------------------------------------------------
#endif

