//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "M2CDlg.h"
//---------------------------------------------------------------------------
#if __BCPLUSPLUS__ != 0x0520
#pragma package(smart_init)
#endif
#pragma resource "*.dfm"
TCoDlg *CoDlg;
//---------------------------------------------------------------------------
__fastcall TCoDlg::TCoDlg(TComponent* AOwner, LPDIRECTPLAY3A lpDP, GUID appGuid, int selected)
  : TForm(AOwner)
{
  lpDP3A = lpDP;
  appguid = appGuid;
  SelectedConnection = selected;

  ConnectionList = new TList();

  // Man2Man Owner TForm ̎͂̂܂Ȃɕ\
  TControl* ctrl = dynamic_cast<TControl*>(Owner);
  if(ctrl){
    TForm* oya = dynamic_cast<TForm*>(GetParentForm(ctrl));
    if(oya){
      Position = poDesigned;
      Left = oya->Left + (oya->Width - Width)/2;
      Top = oya->Top + (oya->Height - Height)/2 + 30;
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TCoDlg::FormShow(TObject *Sender)
{
  lpDP3A->EnumConnections(&appguid,DirectPlayEnumCBack,NULL,0);
  
  ComboBox1->ItemIndex = SelectedConnection;
  if(ComboBox1->ItemIndex != -1)   OKBtn->Enabled = true;
}
//---------------------------------------------------------------------------
BOOL CALLBACK DirectPlayEnumCBack(LPCGUID lpguidSP, LPVOID lpConnection,
     DWORD dwConnectionSize, LPCDPNAME lpName, DWORD dwFlags, LPVOID lpContext)
{
  //T[rXEvoC_̂тɌĂяoR[obN֐
  LPDIRECTPLAY3A pDP;
  HRESULT hr;

  hr = CoCreateInstance(CLSID_DirectPlay,NULL,CLSCTX_ALL,IID_IDirectPlay3A,(LPVOID *)&pDP);
  if(FAILED(hr)) return FALSE;

  hr = pDP->InitializeConnection(lpConnection,0);
  pDP->Release();

  if(FAILED(hr))  // płȂvoC_iInitializeConnectionɎs)
    return TRUE;  // ȂAXgɂ͓ꂸ񋓂𑱂B

  CoDlg->ConnectionList->Add(GlobalAlloc(GPTR, dwConnectionSize));

  if(CoDlg->ConnectionList->Last() == NULL){
    CoDlg->ConnectionList->Delete(CoDlg->ConnectionList->Count - 1);
  }else{
    memcpy(CoDlg->ConnectionList->Last(), lpConnection, dwConnectionSize);
    CoDlg->ComboBox1->Items->Add(lpName->lpszShortNameA);
  }
  return TRUE;
}
//---------------------------------------------------------------------------
void __fastcall TCoDlg::OKBtnClick(TObject *Sender)
{
  //   T[rXvoC_[̏
  HRESULT hr = lpDP3A->InitializeConnection(ConnectionList->Items[ComboBox1->ItemIndex], 0);

  if(FAILED(hr)) ModalResult = 2;

  ModalResult = 1;
}
//---------------------------------------------------------------------------
void __fastcall TCoDlg::CancelBtnClick(TObject *Sender)
{
  ModalResult = 2;
}
//---------------------------------------------------------------------------
void __fastcall TCoDlg::ComboBox1Change(TObject *Sender)
{
  if(ComboBox1->ItemIndex != -1)   OKBtn->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TCoDlg::FormDestroy(TObject *Sender)
{
  for(int i=0;i<ConnectionList->Count;i++)
    GlobalFree(ConnectionList->Items[i]);

  delete ConnectionList;
}
//---------------------------------------------------------------------------

