//----------------------------------------------------------------------------
#ifndef CDlgH
#define CDlgH
//----------------------------------------------------------------------------
#define IDIRECTPLAY2_OR_GREATER
#include <Classes.hpp>
#include <Controls.hpp>
#include <ExtCtrls.hpp>
#include <StdCtrls.hpp>
#include "dplay.h"

#ifndef PACKAGE
  #define PACKAGE
#endif
//----------------------------------------------------------------------------
class TCoDlg : public TForm
{
__published:
  TComboBox *ComboBox1;
  TButton *OKBtn;
  TButton *CancelBtn;
  void __fastcall OKBtnClick(TObject *Sender);
  void __fastcall CancelBtnClick(TObject *Sender);
  void __fastcall ComboBox1Change(TObject *Sender);
  void __fastcall FormDestroy(TObject *Sender);
  void __fastcall FormShow(TObject *Sender);

    
private:
  LPDIRECTPLAY3A lpDP3A;
  TList* ConnectionList;
  GUID appguid;
  int SelectedConnection;
    
public:
  __fastcall TCoDlg(TComponent* AOwner, LPDIRECTPLAY3A lpDP, GUID appGuid, int selected);

friend BOOL CALLBACK DirectPlayEnumCBack(LPCGUID lpguidSP, LPVOID lpConnection,
        DWORD dwConnectionSize, LPCDPNAME lpName, DWORD dwFlags, LPVOID lpContext);
};
//----------------------------------------------------------------------------
extern PACKAGE TCoDlg *CoDlg;
//----------------------------------------------------------------------------
#endif
